
/**
 * This class supplies basic functions that are used in most of my macros.
 * This is the setup function and press a button functions.
 * It also stores the offset for your screen, so you only have to fix it one place.
 * 
 * @McArine
 * @23/02-2008
 */
import java.awt.Robot;
import java.awt.Color;
import java.awt.MouseInfo;
import java.awt.Toolkit;
import java.awt.AWTException;
import java.awt.image.BufferedImage;
import java.awt.Rectangle;
import java.awt.GraphicsDevice;
import java.awt.Point;

public class Functions
{
    //Location of your topleft corner, where you've stacked the windows, in your system coordinates.
    private static int xOffset = 0;
    private static int yOffset = 30;//-2;
    private static int yTimer = 0;
    private static int xTimerLocation = 1892;
    private static int yTimerLocation = 136;
    private boolean IWantToSeeMyFriends = true;
    private boolean IWantToSeeTheTime = true;
    //If you're running linux on multiple screens this should help with putting the mouse the correct place.
    private int numberOfScreens = 2;
    private GraphicsDevice ATitDscreen;
    private GraphicsDevice Mousescreen;
    
    private int FriendsOffset = 194;
    private int ClockLocOffset = 40;
    private int y2Offset = 0;
    private int Width;
    private int Height;
    private int screenWidth;
    private int screenHeight;
    private int RealScreenWidth;
    private int RealScreenHeight;
    private int NumberOfWindows;
    private int NumberOfRows;
    private int WatchTimer;
    public Robot robot;
    public Robot robot2;
    private Color color;
    private Toolkit toolkit;
    private Rectangle rect;
    private BufferedImage image;
    
    public static final int STRENGTH     = 1;
    public static final int DEXTERITY    = 2;
    public static final int ENDURANCE    = 4;
    public static final int SPEED        = 8;
    public static final int CONSTITUTION = 16;
    public static final int FOCUS        = 32;
    public static final int PERCEPTION   = 64;
    
    private int xSetup = 50;
    private int ySetup = 5;//26//28

    //Is called with the following attributes: Width of window, Height of window, number of windows, and number of rows you want on the screen.
    //The robot you're using is also required.
    //Can also be initialized with just the robot.
    public Functions(int InputWidth, int InputHeight, int InputNOW, int InputNOR, boolean Friends, boolean Time, int Timer) {
        Initialize(InputWidth, InputHeight, InputNOW, InputNOR, Friends, Time, Timer);
    }
    
    public Functions(int InputWidth, int InputHeight, int InputNOW, int InputNOR, boolean Friends, boolean Time) {
        Initialize(InputWidth, InputHeight, InputNOW, InputNOR, Friends, Time, 0);
    }
    
    public Functions(int InputWidth, int InputHeight, int InputNOW, int InputNOR) {
        Initialize(InputWidth, InputHeight, InputNOW, InputNOR, IWantToSeeMyFriends, IWantToSeeTheTime, 0);
    }
    
    public Functions(boolean Friends, boolean Time) {
        Initialize(0, 0, 0, 0, Friends, Time, 0);
    }
    
    public Functions(int Timer) {
        Initialize(0, 0, 0, 0, IWantToSeeMyFriends, IWantToSeeTheTime, Timer);
    }
    
    public Functions() {
        Initialize(0, 0, 0, 0, IWantToSeeMyFriends, IWantToSeeTheTime, 0);
    }
    
    private void Initialize(int InputWidth, int InputHeight, int InputNOW, int InputNOR, boolean Friends, boolean Time, int Timer) {
        Width = InputWidth;
        Height = InputHeight;
        NumberOfWindows = InputNOW;
        NumberOfRows = InputNOR;
        IWantToSeeMyFriends = Friends;
        IWantToSeeTheTime = Time;
        //Setup the screens
        ATitDscreen = MouseInfo.getPointerInfo().getDevice();
        try {
            robot = new Robot(ATitDscreen);
        }
        catch (AWTException awte) {
            System.out.println("The Robot was not initialized "+awte + "\n");
        }
        toolkit = Toolkit.getDefaultToolkit();
        ySetup += yOffset;
        if (IWantToSeeMyFriends) {
            xOffset += FriendsOffset;
        }
        if (IWantToSeeTheTime) {
            yOffset += ClockLocOffset;
            y2Offset += ClockLocOffset;
        }
        //RealScreenWidth = toolkit.getScreenSize().width;
        RealScreenWidth = ATitDscreen.getDisplayMode().getWidth();
        //RealScreenHeight = toolkit.getScreenSize().height;
        RealScreenHeight = ATitDscreen.getDisplayMode().getHeight();
        screenWidth = RealScreenWidth - xOffset;
        screenHeight = RealScreenHeight - yOffset;
        if (Timer > 0) {
            SetupTimer();
            WatchTimer = Timer;
        }
    }

    public GraphicsDevice getGDevice() {
        return ATitDscreen;
    }
    
    //PressButton is either called with exact coordinates, or with button coordinates on the first window, 
    //and then with the window number you want the button pressed on.
    //Window numbers go from left to right, top to button. 6 windows, 3 rows:
    //1 2 3
    //4 5 6
    
    public boolean PressButton(int Xcoord, int Ycoord) {
        int xMouse = MouseInfo.getPointerInfo().getLocation().x;
        int yMouse = MouseInfo.getPointerInfo().getLocation().y;
        Mousescreen = MouseInfo.getPointerInfo().getDevice();
        robot.mouseRelease(16);
        robot.delay(10);
        robot.mouseMove(Xcoord, Ycoord);
        robot.delay(10);
        robot.mousePress(16);
        robot.delay(10);
        robot.mouseRelease(16);
        robot.delay(10);
        int xMouse1 = MouseInfo.getPointerInfo().getLocation().x;
        int yMouse1 = MouseInfo.getPointerInfo().getLocation().y;
        if (ATitDscreen.equals(Mousescreen)) {
            robot.mouseMove(xMouse,yMouse);
        }
        else {
            try {
                robot2 = new Robot(Mousescreen);
            }
            catch (AWTException awte) {
                System.out.println("The Robot2 was not initialized "+awte + "\n");
            }
            robot2.mouseMove(xMouse,yMouse);
        }
        if ((Xcoord == xMouse1) && (Ycoord == yMouse1)) return true;
        else return false;
    }
    
    public int MouseInfoX() {
        return MouseInfo.getPointerInfo().getLocation().x;
    }
    
    public int MouseInfoY() {
        return MouseInfo.getPointerInfo().getLocation().y;
    }
    
    public boolean PressButton(int Xcoord, int Ycoord, int WindowNumber) {
        return PressButton((Xcoord + Width * (WindowNumber % NumberOfRows) + xOffset), (Ycoord + Height * (WindowNumber / NumberOfRows) + yOffset));
    }
    
    public void SetupWindows() {
        int xMouse=MouseInfo.getPointerInfo().getLocation().x;
        int yMouse=MouseInfo.getPointerInfo().getLocation().y;
        int tempHeight = Height;
        int tempWidth = Width;
        int temp;
        if (NumberOfRows <= NumberOfWindows) temp = NumberOfRows;
        else temp = NumberOfWindows;
        if (screenWidth < (Width * temp)) {
            Width = screenWidth / temp;
            //I know this is really bad, and that I should be able to get the number through an algoritm, but this works, 
            //and shouldn't take more than one or two runs through the loop.
            while (screenWidth < (tempWidth + Width * (temp - 1))) {
                Width--;
            }
            Width--;
        }
        temp = NumberOfWindows % NumberOfRows;
        if (temp > 0) temp = 1;
        else temp = 0;
        if (screenHeight < (Height * (NumberOfWindows / NumberOfRows + temp))) {
            Height = screenHeight / (NumberOfWindows / NumberOfRows + temp);
            while (screenHeight < (tempHeight + Height * ((NumberOfWindows / NumberOfRows + temp) - 1))) {
                Height--;
            }
            Height--;
        }
        for (int j = (NumberOfWindows - 1); j >= 0; j--) {
            robot.mouseMove(xSetup, ySetup);
            robot.delay(125);
            robot.mousePress(16);
            robot.delay(150);
            robot.mouseMove((xSetup + (j % NumberOfRows) * Width + xOffset), (ySetup + (j / NumberOfRows) * Height + y2Offset));
            robot.delay(150);
            robot.mouseRelease(16);
            robot.delay(150);
        }
        //int Height = tempHeight;
        //int Width = tempWidth;
        robot.mouseMove(xMouse, yMouse);
    }
    
    public void BlankSetupWindows() {
        int tempHeight = Height;
        int tempWidth = Width;
        int temp;
        if (NumberOfRows <= NumberOfWindows) temp = NumberOfRows;
        else temp = NumberOfWindows;
        if (screenWidth < (Width * temp)) {
            Width = screenWidth / temp;
            //I know this is really bad, and that I should be able to get the number through an algoritm, but this works, 
            //and shouldn't take more than one or two runs through the loop.
            while (screenWidth < (tempWidth + Width * (temp - 1))) {
                Width--;
            }
            Width--;
        }
        temp = NumberOfWindows % NumberOfRows;
        if (temp > 0) temp = 1;
        else temp = 0;
        if (screenHeight < (Height * (NumberOfWindows / NumberOfRows + temp))) {
            Height = screenHeight / (NumberOfWindows / NumberOfRows + temp);
            while (screenHeight < (tempHeight + Height * ((NumberOfWindows / NumberOfRows + temp) - 1))) {
                Height--;
            }
            Height--;
        }
    }
    
    public int getIntColor(int Xcoord, int Ycoord, int WindowNumber) {
        return robot.getPixelColor((Xcoord + (WindowNumber % NumberOfRows) * Width + xOffset) , (Ycoord + (WindowNumber / NumberOfRows) * Height + yOffset)).getRGB();
    }
    
    public Color getColor(int Xcoord, int Ycoord, int WindowNumber) {
        return robot.getPixelColor((Xcoord + (WindowNumber % NumberOfRows) * Width + xOffset), (Ycoord + (WindowNumber / NumberOfRows) * Height + yOffset));
    }
    
    public int getIntColor(int Xcoord, int Ycoord) {
        return robot.getPixelColor(Xcoord, Ycoord).getRGB();
    }
    
    public Color getColor(int Xcoord, int Ycoord) {
        return robot.getPixelColor(Xcoord, Ycoord);
    }
    
    public void prepareImage(int xStart, int yStart, int width, int height, int WindowNumber) {
        rect = new Rectangle((xStart + (WindowNumber % NumberOfRows) * Width + xOffset), (yStart + (WindowNumber / NumberOfRows) * Height + yOffset), width, height);
        image = robot.createScreenCapture(rect);
    }
    
    public BufferedImage prepareImage2(int xStart, int yStart, int width, int height, int WindowNumber) {
        rect = new Rectangle((xStart + (WindowNumber % NumberOfRows) * Width + xOffset), (yStart + (WindowNumber / NumberOfRows) * Height + yOffset), width, height);
        return robot.createScreenCapture(rect);
    }
    
    public void prepareImage(int xStart, int yStart, int width, int height) {
        rect = new Rectangle(xStart, yStart, width, height);
        image = robot.createScreenCapture(rect);
    }
    
    public int getImageIntColor(int Xcoord, int Ycoord) {
        return image.getRGB(Xcoord, Ycoord);
    }
    
    public Color getImageColor(int Xcoord, int Ycoord) {
        return new Color(image.getRGB(Xcoord, Ycoord));
    }
    
    public void delay(int Time) {
        robot.delay(Time);
    }
    
    public static int getXOffset() {
        return xOffset;
    }
    
    public static int getYOffset() {
        return yOffset;
    }
    
    public static int getXTimer() {
        return xTimerLocation;
    }
    
    public static int getYTimer() {
        return yTimerLocation;
    }
    
    public int getScreenWidth() {
        return RealScreenWidth;
    }
    
    public int getScreenHeight() {
        return RealScreenHeight;
    }
    
    public void MoveTo(int Xcoord, int Ycoord) {
        robot.mouseMove(Xcoord, Ycoord);
    }
    
    public void MoveTo(Point point) {
        robot.mouseMove(point.x, point.y);
    }
    
    public void MoveTo(int Xcoord, int Ycoord, boolean PressRight) {
        robot.mouseMove(Xcoord, Ycoord);
        if (PressRight) {
            robot.mousePress(8);
            robot.mouseRelease(8);
        }
    }
    
    public void MoveTo(int Xcoord, int Ycoord, int WindowNumber) {
        robot.mouseMove((Xcoord + (WindowNumber % NumberOfRows) * Width + xOffset), (Ycoord + (WindowNumber / NumberOfRows) * Height + yOffset));
    }
    
    public void MoveTo(int Xcoord, int Ycoord, boolean PressRight, int WindowNumber) {
        robot.mouseMove((Xcoord + (WindowNumber % NumberOfRows) * Width + xOffset), (Ycoord + (WindowNumber / NumberOfRows) * Height + yOffset));
        robot.delay(100);
        if (PressRight) {
            robot.mousePress(8);
            robot.delay(100);
            robot.mouseRelease(8);
        }
    }
    
    public void MoveWindow(int XStart, int YStart, int XEnd, int YEnd, int WindowNumber) {
        int xMouse = MouseInfo.getPointerInfo().getLocation().x;
        int yMouse = MouseInfo.getPointerInfo().getLocation().y;
        Mousescreen = MouseInfo.getPointerInfo().getDevice();
        robot.mouseRelease(16);
        robot.mouseMove((XStart + Width * (WindowNumber % NumberOfRows) + xOffset), (YStart + Height * (WindowNumber / NumberOfRows) + yOffset));
        robot.mousePress(16);
        robot.delay(200);
        robot.mouseMove((XEnd + Width * (WindowNumber % NumberOfRows) + xOffset), (YEnd + Height * (WindowNumber / NumberOfRows) + yOffset));
        robot.delay(200);
        robot.mouseRelease(16);
        if (ATitDscreen.equals(Mousescreen)) {
            robot.mouseMove(xMouse,yMouse);
        }
        else {
            try {
                robot2 = new Robot(Mousescreen);
            }
            catch (AWTException awte) {
                System.out.println("The Robot2 was not initialized "+awte + "\n");
            }
            robot2.mouseMove(xMouse,yMouse);
        }
    }
    
    public void MoveWindow(int XStart, int YStart, int XEnd, int YEnd) {
        int xMouse = MouseInfo.getPointerInfo().getLocation().x;
        int yMouse = MouseInfo.getPointerInfo().getLocation().y;
        Mousescreen = MouseInfo.getPointerInfo().getDevice();
        robot.mouseRelease(16);
        robot.mouseMove(XStart, YStart);
        robot.mousePress(16);
        robot.delay(50);
        robot.mouseMove(XEnd, YEnd);
        robot.delay(500);
        robot.mouseRelease(16);
        if (ATitDscreen.equals(Mousescreen)) {
            robot.mouseMove(xMouse,yMouse);
        }
        else {
            try {
                robot2 = new Robot(Mousescreen);
            }
            catch (AWTException awte) {
                System.out.println("The Robot2 was not initialized "+awte + "\n");
            }
            robot2.mouseMove(xMouse,yMouse);
        }
    }
    
    public void beep() {
        toolkit.beep();
    }
    
    private boolean SetupTimer() {
        Color location;
        boolean isOk = false;
        for (int i = 5; i < 15; i++) {
            location = robot.getPixelColor(i, RealScreenHeight-2);
            if ((location.getRed() > 230) && (location.getGreen() > 230) && (location.getBlue() < 90)) {
                isOk = true;
                break;
            }
        }
        if (isOk) {
            isOk = false;
            for (int j = RealScreenHeight - 5; j > 0; j--) {
                location = robot.getPixelColor(5, j);
                if ((location.getRed() > 160) && (location.getRed() < 210) && (location.getGreen() > 200) && (location.getGreen() < 240) && (location.getBlue() > 120) && (location.getBlue() < 170)) {
                    isOk = true;
                    yTimer = j;
                    break;
                }
            }
            if (!isOk) {
                System.out.println("Please make sure that the skills tab is open, and that the skills area is viewable on the screen");
            }
        }
        else {
            System.out.println("The egenesis client was not found. Please make sure that the skills tab is open, and that the skills area is viewable on the screen");
        }
        return isOk;
    }
    
    public boolean WaitForTimer() {
        return WaitForTimer(false);
    }
    
    public boolean WaitForTimer(boolean Black) {
        if (WatchTimer == 0) {
            System.out.println("Functions not set up with a timer");
            return false;
        }
        robot.delay(500);
        int CheckTimers = WatchTimer;
        if (CheckTimers >= PERCEPTION) {    
            CheckTimers -= PERCEPTION;
            if (CheckTimer(129, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers >= FOCUS) {    
            CheckTimers -= FOCUS;
            if (CheckTimer(114, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers >= CONSTITUTION) {    
            CheckTimers -= CONSTITUTION;
            if (CheckTimer(100, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers >= SPEED) {    
            CheckTimers -= SPEED;
            if (CheckTimer(84, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers >= ENDURANCE) {    
            CheckTimers -= ENDURANCE;
            if (CheckTimer(72, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers >= DEXTERITY) {    
            CheckTimers -= DEXTERITY;
            if (CheckTimer(58, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers >= STRENGTH) {    
            CheckTimers -= STRENGTH;
            if (CheckTimer(42, Black)) {
                if (CheckTimers == 0) {
                    return true;
                }
            }
            else {
                return false;
            }
        }
        if (CheckTimers == 0) {
            System.out.println("There's something wrong with the timer section of functions.");
            return true;
        }
        else {
            System.out.println("You've initialised Functions using a wrong integer for timers.");
            return false;
        }
    }
    
    private boolean CheckTimer(int Location, boolean Black) {
        Color TimerLocation = robot.getPixelColor(14, yTimer + Location);
        while (true) {
            if ((TimerLocation.getGreen() == 0) && (TimerLocation.getBlue() == 0)) {
                if (Black && (TimerLocation.getRed() == 0)) {
                    return true;
                }
                else if (!Black && (TimerLocation.getRed() < 255)) {
                    return true;
                }
                else {
                    robot.delay(100);
                    TimerLocation = robot.getPixelColor(14, yTimer + Location);
                }
            }
            else {
                if (SetupTimer()) {
                    robot.delay(100);
                    TimerLocation = robot.getPixelColor(14, yTimer + Location);
                }
                else {
                    System.out.println("The macro has lost the egenesis window.");
                    return false;
                }
            }
        }
    }
    
    public void SetTimer(int Timer) {
        WatchTimer = Timer;
    }
    
    public void pressKeyM(int Xcoord, int Ycoord) {
        int xMouse=MouseInfo.getPointerInfo().getLocation().x;
        int yMouse=MouseInfo.getPointerInfo().getLocation().y;
        Mousescreen = MouseInfo.getPointerInfo().getDevice();
        robot.mouseRelease(16);
        robot.mouseMove(Xcoord, Ycoord);
        robot.delay(50);
        robot.keyPress(java.awt.event.KeyEvent.VK_W);
        robot.keyRelease(java.awt.event.KeyEvent.VK_W);
        if (ATitDscreen.equals(Mousescreen)) {
            robot.mouseMove(xMouse,yMouse);
        }
        else {
            try {
                robot2 = new Robot(Mousescreen);
            }
            catch (AWTException awte) {
                System.out.println("The Robot2 was not initialized "+awte + "\n");
            }
            robot2.mouseMove(xMouse,yMouse);
        }
    }
    
    public void pressKeyEnter() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_ENTER);
        robot.keyRelease(java.awt.event.KeyEvent.VK_ENTER);
    }
    
    public void pressKeyE() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_E);
        robot.keyRelease(java.awt.event.KeyEvent.VK_E);
    }
    
    public void pressKeyS() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_S);
        robot.keyRelease(java.awt.event.KeyEvent.VK_S);
    }
    
    public void pressKeyN() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_N);
        robot.keyRelease(java.awt.event.KeyEvent.VK_N);
    }
    
    public void pressKeyW() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_W);
        robot.keyRelease(java.awt.event.KeyEvent.VK_W);
    }
    
    public void pressKeyH() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_H);
        robot.keyRelease(java.awt.event.KeyEvent.VK_H);
    }
    
    public void pressKeyT() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_T);
        robot.keyRelease(java.awt.event.KeyEvent.VK_T);
    }
    
    public void pressKeyB() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_B);
        robot.keyRelease(java.awt.event.KeyEvent.VK_B);
    }
    
    public void pressKeyP() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_P);
        robot.keyRelease(java.awt.event.KeyEvent.VK_P);
    }
    
    public void pressKeyC() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_C);
        robot.keyRelease(java.awt.event.KeyEvent.VK_C);
    }
    
    public void pressKeyF() {
        robot.delay(100);
        robot.keyPress(java.awt.event.KeyEvent.VK_F);
        robot.keyRelease(java.awt.event.KeyEvent.VK_F);
    }
}
